window.app = {};
localStorage.pro = 'false';
(function(exports) {
    var hostURL = 'http://whatthedude.com/open';
    // var hostURL = 'http://192.168.0.3/open';
    var urlField = document.getElementById('url');
    var exit = function() {
        navigator.app.exitApp();
    };
    var computers = document.getElementById('computers');
    var pro = document.getElementById('pro');

    var fillUrl = function(url) {
        urlField.value = url;
    };

    var autoFillUrl = function() {
	console.log('ready!', location.hash);
        if (location.hash.indexOf('internal') === -1) {
	    // #internal isn't present.
	    // So either the user opened the app or we caught
	    // an intent
	    if (location.hash) {
		fillUrl(location.hash.slice(1));
	    }
	    else {
                CDV.WEBINTENT.getUri(fillUrl);
                CDV.WEBINTENT.getExtra(CDV.WEBINTENT.EXTRA_TEXT, fillUrl);
	    }
        }
    };

    var response = document.getElementById('response');
    var receivedResponse = false;

    exports.initialize = function() {
        if (localStorage.pro === 'false') {
            computers.style.display = 'none';
            pro.style.display = 'none';
        }
        document.addEventListener('deviceready', autoFillUrl, false);
	window.addEventListener('hashchange', function() {
	    autoFillUrl();
	    response.style.display = 'none';
	}, false);
	
        document.getElementById('form').addEventListener('submit', function(e) {
            e.preventDefault();
            exports.sendURL(urlField.value, computers.selectedIndex);
        }, false);
        document.addEventListener('backbutton', exit, false);
        document.addEventListener('menubutton', exit, false);
    };

    exports.sendURL = function(url, selection) {
        var devices = [];
        if (localStorage.devices) {
            devices = JSON.parse(localStorage.devices);
        }

        var obj = {}; // The obj we'll stringify and send to the server
        obj.paid = Boolean(localStorage.pro);
        obj.url = url;
        obj.id = devices[selection].id;
        obj.pass = devices[selection].pass;
        fillUrl(url);

        localStorage.lastCompID = obj.id;

        if (!(obj.id && obj.url)) {
            return;
        }

        if (!obj.pass) {
            obj.pass = '';
        }

        urlField.disabled = 'disabled';
        urlField.parentNode.style.borderColor = '#969696';
        var XHR = new XMLHttpRequest();
        XHR.open('POST', hostURL);
        animate();

        XHR.onreadystatechange = function() {
            if (XHR.readyState === 4) {
                response.className = 'red';
                switch (XHR.responseText) {
                    case '200':
                        response.className = 'green';
                        receivedResponse = 'Sent to Chrome!';
                        break;
                    case '418':
                        response.className = 'green';
                        receivedResponse = 'Added to queue.';
                        break;
                    case '401':
                        receivedResponse = 'Computer is offline and failed to queue link; incorrect passphrase.';
                        break;
                    case '404':
                        receivedResponse = 'Computer is offline. The Pro version can queue links for later!';
                        break;
                    case '400':
                        receivedResponse = 'Required parameters missing.';
                        break;
                    case '503':
                        receivedResponse = 'Incorrect passphrase. Make sure it\'s the same here and in the extension.';
                        break;
                };
            }
        };
        XHR.setRequestHeader('Content-Type', 'application/json');
        XHR.send(JSON.stringify(obj));
    };

    var anim = document.getElementById('anim');

    var node;
    var reset = function() {
        for (var i = 0; i < anim.childNodes.length; i++) {
            node = anim.childNodes[i];
            if (node.nodeType === Node.ELEMENT_NODE) {
                node.style.marginLeft = '-1000px';
            }
        }
        if (receivedResponse) {
            urlField.disabled = '';
            urlField.parentNode.style.borderColor = '';
            response.style.display = 'block';
            response.textContent = receivedResponse;
            receivedResponse = false;
        } else {
            animate();
        }
    };

    var outAnim = function() {
        TweenMax.staggerTo(anim.childNodes, 0.3, {
            marginLeft: '700',
            delay: 0.25
        }, 0.1, reset);
    };

    window.animate = function() {
        response.style.display = 'none';
        console.log('Anim');
        TweenMax.staggerTo(anim.childNodes, 0.2, {
            marginLeft: '0'
        }, 0.25, outAnim);
    };

    var target;
    var openLink = function(e) {
        console.log('Clicked');
        target = e.target;
        if (target.rel !== 'external') {
            return true;
        }
        e.preventDefault();
        CDV.WEBINTENT.startActivity({
                action: CDV.WEBINTENT.ACTION_VIEW,
                url: 'twitter://user?screen_name=' + e.target.getAttribute('data-user')
            },
            function() {

            },
            function() {
                console.log('Failed to open URL via Android Intent');
            }
        );
        return false;
    };

    var links = document.getElementsByTagName('a');
    for (var i = 0; i < links.length; i++) {
        links[i].addEventListener('click', openLink, false);
    }

    var devices;
    var option;
    try {
        if (localStorage.devices) {
            devices = JSON.parse(localStorage.devices);
            for (var i = 0; i < devices.length; i++) {
                option = document.createElement('option');
                option.value = devices[i].id;
                option.appendChild(document.createTextNode(devices[i].name || devices[i].id || '-- Report this to @AmaanC, please?'));
                computers.appendChild(option);
                if (localStorage.lastCompID && localStorage.lastCompID === option.value) {
                    computers.selectedIndex = i;
                }
            }
        }
    } catch (e) {
        console.log(e);
    }

    var newMessage = document.getElementById('newMessage');
    if (!devices || devices.length === 0 || !devices[0].id) {
        newMessage.style.display = 'block';
        form.style.display = 'none';
        document.getElementsByClassName('app')[0].style.margin = '30px auto';
    }
})(app);
